/*  sensor_applet

    Copyright (C) 2001 Osamu Kayasono <jacobi@jcom.home.ne.jp>

    This program is GNOME applet for reading lm_sensors statistics.
	Please read README for more details.
*/

#include "main.h"

/*
******* MAIN ROUTINE *******

int old_main(int argc, char *argv[]) {
   char chips[STRMAX];
   
#ifdef ENABLE_NLS
   bindtextdomain(PACKAGE, GNOMELOCALEDIR);
   textdomain(PACKAGE);
#endif

   if (find_chips(chips) == 1) {
      printf( _("%s : lm_sensors is not activate\n"),PACKAGE);
      exit(1);
   }

   g_main(argc, &argv, chips);

   return (0);
}
*/

int find_chips(char *chips) {
   FILE *f;
   char buf[BUF_MAX];
   char FULLPATH[STRMAX],  val1[STRMAX],    val2[STRMAX];
   char chips_isa[STRMAX], chips_i2c[STRMAX];
   
   sprintf(FULLPATH,"%schips",SENSEPATH);
   if ((f=fopen(FULLPATH,"r")) == NULL) return (1);

   while (fgets(buf, sizeof buf, f) != NULL) {
      sscanf(buf,"%s %s", val1, val2);
      if (strstr(val2,"i2c") != NULL) sprintf(chips_i2c,"%s",val2);
      if (strstr(val2,"isa") != NULL) sprintf(chips_isa,"%s",val2);
   }
   fclose(f);

   if (strstr(chips_isa,"isa") != NULL) {
      sprintf(chips,"%s",chips_isa);
      return (0);
   }
   if (strstr(chips_i2c,"i2c") != NULL) {
      sprintf(chips,"%s",chips_i2c);
      return (0);
   }

   return (1);
}

float read_val(char *chips, char *path, int m) {
  FILE *f;
  char FULLPATH[STRMAX];
  char buf[BUF_MAX];
  float tmp[3];

  sprintf(FULLPATH,"%s%s/%s",SENSEPATH,chips,path);
  /* return DISABLE, when specified sensor is not exist */
  if ((f=fopen(FULLPATH,"r")) == NULL) return DISABLE;
  fgets(buf, sizeof buf, f);
  fclose(f);
  sscanf(buf,"%f %f %f\n",&tmp[1],&tmp[2],&tmp[3]);

  /* Fan parameters are current value and low limit */
  if (strncmp(path,"fan",3) == 0) {
    switch(m){
    case -1:
      return tmp[1];
      break;
    case 1:
      return DISABLE;
      break;
    default:
      return tmp[2];
      break;
    }      
  }

  /* Temp. parameters are current value and high limit */
  if (strncmp(path,"temp",4) == 0) {
    switch(m){
    case -1:
      return DISABLE;
      break;
    case 1:
      return tmp[1];
      break;
    default:
      return tmp[3];
      break;
    }
  }

  /* Voltages */
    switch(m){
    case -1:
      return tmp[1];
      break;
    case 1:
      return tmp[2];
      break;
    default:
      return tmp[3];
      break;
    }
}

