#ifndef WITH_GAI

#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <applet-widget.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "main.h"
#include "sensor_applet.h"

GtkWidget *sentry[6], *nentry[6];

void property_load(gchar *path, SensorApplet *ai)
{
  gnome_config_push_prefix (path);

  ai->height = gnome_config_get_int("sensor_applet/height=48");
  ai->width = gnome_config_get_int("sensor_applet/width=64");
  ai->sensorFreq = gnome_config_get_int("sensor_applet/sensorFreq=3");

  ai->label[1] = gnome_config_get_string("sensor_applet/label1=CPU");
  ai->label[2] = gnome_config_get_string("sensor_applet/label2=M/B");
  ai->label[3] = gnome_config_get_string("sensor_applet/label3=FAN1");
  ai->label[4] = gnome_config_get_string("sensor_applet/label4=FAN2");
  ai->label[5] = gnome_config_get_string("sensor_applet/label5=CORE");

  ai->sensor[1] = gnome_config_get_string("sensor_applet/sensor1=temp2");
  ai->sensor[2] = gnome_config_get_string("sensor_applet/sensor2=temp1");
  ai->sensor[3] = gnome_config_get_string("sensor_applet/sensor3=fan1");
  ai->sensor[4] = gnome_config_get_string("sensor_applet/sensor4=fan2");
  ai->sensor[5] = gnome_config_get_string("sensor_applet/sensor5=in0");

  gnome_config_pop_prefix ();

  return;
}

void delete_event(GtkWidget *widget, GdkEvent *event, gpointer data){
  applet_widget_gtk_main_quit();
  return;
};

void quit_applet(AppletWidget *applet, gpointer data){
  applet_widget_gtk_main_quit();
  return;
};

gint save_session_cb (GtkWidget *widget,
	gchar *privcfgpath,
	gchar *globcfgpath,
	gpointer data)
{
  SensorApplet *ai=data;

  gnome_config_push_prefix (privcfgpath);
  gnome_config_set_int("sensor_applet/height",ai->height);
  gnome_config_set_int("sensor_applet/width",ai->width);
  gnome_config_set_int("sensor_applet/sensorFreq",ai->sensorFreq);

  gnome_config_set_string("sensor_applet/label1",ai->label[1]);
  gnome_config_set_string("sensor_applet/label2",ai->label[2]);
  gnome_config_set_string("sensor_applet/label3",ai->label[3]);
  gnome_config_set_string("sensor_applet/label4",ai->label[4]);
  gnome_config_set_string("sensor_applet/label5",ai->label[5]);

  gnome_config_set_string("sensor_applet/sensor1",ai->sensor[1]);
  gnome_config_set_string("sensor_applet/sensor2",ai->sensor[2]);
  gnome_config_set_string("sensor_applet/sensor3",ai->sensor[3]);
  gnome_config_set_string("sensor_applet/sensor4",ai->sensor[4]);
  gnome_config_set_string("sensor_applet/sensor5",ai->sensor[5]);

  gnome_config_sync ();
  gnome_config_pop_prefix ();
/*  gnome_config_drop_all (); */

  return FALSE;
  widget = NULL;
  globcfgpath = NULL;
}

void properties_apply_cb (GtkWidget *b, gint page_num, gpointer data)
{
  SensorApplet *ai=data;
  gchar *tmp;
  gint i;

  /* save sensor config */
  for (i = 1; i <= 5; i++) {
    tmp = gtk_entry_get_text(GTK_ENTRY(nentry[i]));
    if ((!ai->label[i] && tmp && strlen(tmp) > 0) ||
	(ai->label[i] && !tmp) ||
	(ai->label[i] && tmp && strcmp(ai->label[i], tmp) != 0))
      {
	g_free(ai->label[i]);
	ai->label[i] = NULL;
	if (tmp && strlen(tmp) > 0) ai->label[i] = g_strdup(tmp);
      }
     
    tmp = g_strdup(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sentry[i])->entry)));
    if ((!ai->sensor[i] && tmp && strlen(tmp) > 0) ||
	(ai->sensor[i] && !tmp) ||
	(ai->sensor[i] && tmp && strcmp(ai->sensor[i], tmp) != 0))
      {
	g_free(ai->sensor[i]);
	ai->sensor[i] = NULL;
	if (tmp && strlen(tmp) > 0) ai->sensor[i] = g_strdup(tmp);
      }
  }

  /* update Sensor Frequency */
  ai->sensorFreq = GTK_ADJUSTMENT (ai->Freq_adj)->value;
  gtk_timeout_remove (ai->timeout_id);
  ai->timeout_id = gtk_timeout_add(ai->sensorFreq * 1000, 
				   (GtkFunction)update_val, ai);

  applet_widget_sync_config (APPLET_WIDGET (ai->applet));

  return;
}



void about_cb (AppletWidget *widget, gpointer data)
{
   static GtkWidget *about = NULL;

   const gchar *authors[] = {
      _("Osamu Kayasono <jacobi@jcom.home.ne.jp>"), NULL };
   
   if (about != NULL)
   {
	gdk_window_show(about->window);
	gdk_window_raise(about->window);
	return;
   }

   about = gnome_about_new (PACKAGE, VERSION,
			  NULL,
			  authors,
   			  _("a GNOME applet that reads and displays "
   			    "statistics of lm_sensors"),
   	NULL);
   gtk_signal_connect( GTK_OBJECT(about), "destroy",
		       GTK_SIGNAL_FUNC(gtk_widget_destroyed), &about );
   gtk_widget_show (about);
   return;
   widget = NULL;
   data = NULL;

  return;
}

static GSList*
GetEntries(void)
{
  GSList *names = NULL;

  names=g_slist_append(names,"fan1");
  names=g_slist_append(names,"fan2");
  names=g_slist_append(names,"fan3");

  names=g_slist_append(names,"in0");
  names=g_slist_append(names,"in1");
  names=g_slist_append(names,"in2");
  names=g_slist_append(names,"in3");
  names=g_slist_append(names,"in4");
  names=g_slist_append(names,"in5");
  names=g_slist_append(names,"in6");

  names=g_slist_append(names,"temp1");
  names=g_slist_append(names,"temp2");
  names=g_slist_append(names,"temp3");

  return names;
}

static void
setup_help(void)
{
  GtkWidget *mbox;
  mbox = gnome_message_box_new(_("Sorry. help file is not available."),
			       GNOME_MESSAGE_BOX_ERROR,
			       _("Close"), NULL);
  gtk_widget_show(mbox);
}

void
adj_value_changed_cb ( GtkAdjustment * ignored, gpointer data )
{
  SensorApplet *ai = data;

  gnome_property_box_changed (GNOME_PROPERTY_BOX (ai->pbox)); 
  return;
  ignored = NULL;
}

void properties (AppletWidget *widget, gpointer data)
{
  SensorApplet *ai=data;
  GtkWidget *notebook, *vbox, *title1;
  GtkWidget *hbox[6], *caption[6];
  GtkWidget *listitem;
  GtkWidget *title2, *frame1, *frame2, *hbox1, *hbox2, *vbox2;
  GtkWidget *label1, *label2, *chip;
  GtkObject *spinbutton2_adj;
  GtkWidget *spinbutton2;
  GSList *tmp;
  gint i;

  ai->pbox = gnome_property_box_new();
  gtk_window_set_title (GTK_WINDOW(
      &GNOME_PROPERTY_BOX(ai->pbox)->dialog.window),
      _("sensor_applet properties"));

  gtk_object_set_data (GTK_OBJECT(ai->pbox), "properties", ai->pbox);

  /* make "Sensor Config" page */
  notebook = GNOME_PROPERTY_BOX (ai->pbox)->notebook;
  gtk_object_set_data (GTK_OBJECT(ai->pbox), "notebook", notebook);
  gtk_widget_show (notebook);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "vbox", vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);

  for (i = 1; i <= 5; i++) {

    hbox[i] = gtk_hbox_new (FALSE, 0);
    gtk_widget_ref (hbox[i]);
    gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "hbox", hbox[i],
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (hbox[i]);
    gtk_box_pack_start (GTK_BOX (vbox), hbox[i], TRUE, TRUE, 0);

    switch(i) {
    case 1:
      caption[i] = gtk_label_new (_("sensor 1"));
      break;
    case 2:
      caption[i] = gtk_label_new (_("sensor 2"));
      break;
    case 3:
      caption[i] = gtk_label_new (_("sensor 3"));
      break;
    case 4:
      caption[i] = gtk_label_new (_("sensor 4"));
      break;
    default:
      caption[i] = gtk_label_new (_("sensor 5"));
      break;
    }
    gtk_widget_ref (caption[i]);
    gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "caption", caption[i],
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (caption[i]);
    gtk_box_pack_start (GTK_BOX (hbox[i]), caption[i], FALSE, FALSE, 0);

    nentry[i] = gtk_entry_new_with_max_length (4);
    gtk_widget_ref (nentry[i]);
    gtk_object_set_data_full (GTK_OBJECT(ai->pbox),"nentry", nentry[i],
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (nentry[i]);
    gtk_box_pack_start (GTK_BOX (hbox[i]), nentry[i], TRUE, TRUE, 0);
    gtk_entry_set_text(GTK_ENTRY(nentry[i]),ai->label[i]);
    gtk_signal_connect_object(GTK_OBJECT(nentry[i]), "changed",
	  GTK_SIGNAL_FUNC(gnome_property_box_changed),GTK_OBJECT(ai->pbox));

    sentry[i] = gtk_combo_new ();
    gtk_widget_ref (sentry[i]);
    gtk_object_set_data_full (GTK_OBJECT(ai->pbox),"sentry",
			      sentry[i],(GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (sentry[i]);
    listitem = gtk_list_item_new();
    tmp = GetEntries();
    while(tmp){ 
      listitem = gtk_list_item_new_with_label ((gchar*)(tmp->data));
      gtk_widget_show( listitem );  
      gtk_container_add( GTK_CONTAINER( GTK_COMBO(sentry[i])->list),listitem);
      tmp=g_slist_next(tmp);
    }

    gtk_box_pack_start (GTK_BOX (hbox[i]), sentry[i], TRUE, TRUE, 0);
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(sentry[i])->entry),ai->sensor[i]);
    gtk_signal_connect_object(GTK_OBJECT(GTK_COMBO(sentry[i])->list), 
	"selection-changed",
	GTK_SIGNAL_FUNC(gnome_property_box_changed),GTK_OBJECT(ai->pbox));
  }

  title1 = gtk_label_new ("Sensors Config");
  gtk_widget_ref (title1);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "title1",
			    title1,(GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (title1);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 0), title1);


  /* make "Sensor Config" page */

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (notebook), vbox2);

  frame1 = gtk_frame_new (_("Sensor Chip"));
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_container_add (GTK_CONTAINER (vbox2), frame1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame1), hbox1);

  label1 = gtk_label_new (ai->chips);
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, FALSE, 0);

  frame2 = gtk_frame_new (_("Update Freq"));
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_container_add (GTK_CONTAINER (vbox2), frame2);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (frame2), hbox2);

  label2 = gtk_label_new (_("Sensors update Frequency (sec)"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox2), label2, FALSE, FALSE, 0);

  ai->Freq_adj = gtk_adjustment_new ((ai->sensorFreq), 1, 100, 1, 10, 10);
  spinbutton2 = gtk_spin_button_new (GTK_ADJUSTMENT (ai->Freq_adj), 1, 0);
  gtk_signal_connect (GTK_OBJECT (ai->Freq_adj), "value_changed",
		     GTK_SIGNAL_FUNC(adj_value_changed_cb),ai);
	
  gtk_widget_ref (spinbutton2);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "spinbutton2", spinbutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton2);
  gtk_box_pack_start (GTK_BOX (hbox2), spinbutton2, TRUE, TRUE, 0);

  title2 = gtk_label_new (_("Others Config"));
  gtk_widget_ref (title2);
  gtk_object_set_data_full (GTK_OBJECT(ai->pbox), "title2", title2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (title2);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 1), title2);

  /* signal */

  gtk_signal_connect (GTK_OBJECT(ai->pbox),
		      "apply", GTK_SIGNAL_FUNC (properties_apply_cb), ai);
  gtk_signal_connect (GTK_OBJECT(ai->pbox), "help",
		      GTK_SIGNAL_FUNC (setup_help), NULL);

  gtk_widget_show_all (ai->pbox);

  return;
}

#endif
